//
// Virtual Database Interface Class
//
// Author: Christoph Dalitz, June 2004
//

#ifndef _dbiH
#define _dbiH

#include <string>
#include <list>

using std::string;
using std::list;

typedef list<string> StringList;

class Dbi {

 public:
  Dbi() { lasterror = ""; }
  virtual ~Dbi() {};
  virtual int Login(const char* dbname, const char* user, const char* passwd) = 0;
  virtual void Logout() = 0;
  // select returns first row in res
  virtual int Select(const char* sql, StringList* res) = 0;
  virtual int NonSelect(const char* sql) = 0;
  int Begin() { return NonSelect("BEGIN"); }
  int Commit() { return NonSelect("COMMIT"); }
  int Rollback() { return NonSelect("ROLLBACK"); }
  char* LastError() { return (char*)lasterror.c_str(); }

 protected:
  string lasterror;
};

// virtual Constructor of the generic class
Dbi* ConstructDbi();

#endif
